var version = "3.02.18";
var AAO_URL_PART_IGP = "http://localhost:";
var apiport = 0;
var fipport = 0;
const toggledPanels = [];
var panelhidden = 0;
var borderhidden = 0;
var currZoom = 0.0;
var bodyBackground = {};
var origBackground = {};
var origBorder = {};
var simvars = {};
var processBVars = true;

function fipsPanelDataRequestListener() {
	try {
		if (document.body.style.border !== "none")
			document.body.style.border = "none";
		var commObj = JSON.parse(this.responseText);
		var modidx = SimVar.GetSimVarValue('L:AaoBvarProc', 'Number');
		if (modidx > 0 && processBVars)
			processBVars = false;
		var hidePanel = SimVar.GetSimVarValue('L:AAO_PANEL_TWO_HIDDEN', 'Number');
		var iframe = document.getElementById("FipsFrame");
		var borderPanel = SimVar.GetSimVarValue('L:AAO_PANEL_TWO_BORDER_HIDDEN', 'Number');
		var zoomLevel = SimVar.GetSimVarValue('L:AAO_PANEL_TWO_ZOOM', 'Number');
		if (zoomLevel != currZoom && zoomLevel != 0) {
			iframe.style.transform = `scale(${zoomLevel})`;
			iframe.style.width = `${100 * (1 / zoomLevel)}%`;
			iframe.style['transform-origin'] = `0 0`;

			// document.firstElementChild.style.zoom = "" + (100*zoomLevel).toString() + "%";
			currZoom = zoomLevel;
		}
		var returnRequestObj = {};
		returnRequestObj.setvars = [];
		returnRequestObj.setstringvars = [];
		if (hidePanel != panelhidden) {
			panelhidden = hidePanel;
			var ingameUi = document.getElementById("LorbyAaoPanel");
			if (panelhidden == 1 && ingameUi.style.display !== "none") {
				ingameUi.style.display = "none";
			} else {
				ingameUi.style.display = "";
			}
		}
		if (borderPanel != borderhidden) {
			borderhidden = borderPanel;
			var ingameUi = document.getElementById("LorbyAaoPanel");
			if (borderhidden == 1) {
				bodyBackground = document.body.backgroundColor;
				document.body.style.backgroundColor = "#00000000";
				document.getElementsByTagName("ingame-ui-header")[0].classList.add("hidden");
				origBackground = document.getElementById("LorbyAaoPanel").style.backgroundColor;
				document.getElementById("LorbyAaoPanel").style.backgroundColor = "#00000000";
				origBorder = document.getElementById("FipsFrame").style.border;
				document.getElementById("FipsFrame").style.border = "none";
			} else {
				document.body.style.backgroundColor = bodyBackground;
				document.getElementsByTagName("ingame-ui-header")[0].classList.remove("hidden");
				document.getElementById("LorbyAaoPanel").style.backgroundColor = origBackground;
				document.getElementById("FipsFrame").style.border = origBorder;
			}
		}
		let sendReply = false;
		var refreshPanel = SimVar.GetSimVarValue('L:AAO_PANEL_TWO_RELOAD', 'Number');
		SimVar.SetSimVarValue('L:AAO_PANEL_TWO_RELOAD', 'Number', 0);
		if (commObj.getstringvars[0] && commObj.getstringvars[0].value) {
			if (refreshPanel == 1 || !iframe.src.startsWith(commObj.getstringvars[0].value)) {
				iframe.src = commObj.getstringvars[0].value;
			}
		}
		else {
			if (refreshPanel == 1 || !iframe.src.startsWith(AAO_URL_PART_IGP + fipport.toString() + "/webfips")) {
				iframe.src = AAO_URL_PART_IGP + fipport.toString() + "/webfips";
			}
		}
		if (sendReply) {
			var url = encodeURI(AAO_URL_PART_IGP + apiport.toString() + "/webapi/");
			var dataxhttp = new XMLHttpRequest();
			dataxhttp.timeout = 500;
			dataxhttp.open("POST", url, true);
			dataxhttp.send(JSON.stringify(returnRequestObj));
		}
	} catch (err) {
		simvars = {};
		var errRequestObj = {};
		errRequestObj.setstringvars = [];
		var eurl = encodeURI(AAO_URL_PART_IGP + apiport.toString() + "/webapi/");
		var edataxhttp = new XMLHttpRequest();
		edataxhttp.timeout = 250;
		edataxhttp.open("POST", eurl, true);
		edataxhttp.send(JSON.stringify(errRequestObj));
	}
}

function fipsPanelDataRequestError() {
	document.body.style.border = "5px solid red";
	SimVar.SetSimVarValue('L:AAO_PANEL_TWO_RELOAD', 'Number', -2);
	var iframe = document.getElementById("FipsFrame");
	iframe.src = AAO_URL_PART_IGP + fipport.toString() + "/webfips";
}

function fipsPanelDataRequest() {
	if (apiport > 1) {
		var mainLoopRequestObj = {};
		mainLoopRequestObj.getstringvars = [];
		var toget = { "var": "(L:AAO_PANEL_TWO_URL, String)", "value": "" };
		mainLoopRequestObj.getstringvars.push(toget);
		var url = encodeURI(AAO_URL_PART_IGP + apiport.toString() + "/webapi/");
		var dataxhttp = new XMLHttpRequest();
		dataxhttp.addEventListener("load", fipsPanelDataRequestListener);
		dataxhttp.addEventListener("error", fipsPanelDataRequestError);
		dataxhttp.timeout = 250;
		dataxhttp.open("POST", url, true);
		dataxhttp.send(JSON.stringify(mainLoopRequestObj));
	} else {
		apiport = SimVar.GetSimVarValue('L:AaoWebApiPort', 'Number') + 1;
		fipport = SimVar.GetSimVarValue('L:AaoWebFipsPort', 'Number');
	}
}


function changedWindowSize() {
	SimVar.SetSimVarValue('L:AAO_PANEL_TWO_RELOAD', 'Number', 1);
}

window.onresize = changedWindowSize;

class IngamePanelAaoFipsPanel extends TemplateElement {
	constructor() {
		super(...arguments);
		this.updateLoop = () => {
			requestAnimationFrame(this.updateLoop);
		};
		this.myInterval = setInterval(fipsPanelDataRequest, 100);
		this.onShow = () => {
			// this.myInterval = setInterval(fipsPanelDataRequest, 200);
		};
		this.onHide = () => {
			clearInterval(this.myInterval);
		};
		this.panelActive = false;
		this.started = false;
		this.ingameUi = null;
		this.closeButton = null;
		this.busy = false;
		this.debugEnabled = false;
		this.initialize();
	}
	isDebugEnabled() {
	}
	connectedCallback() {
		super.connectedCallback();
		var iframe = document.getElementById("FipsFrame");
		if (iframe) {
			iframe.src = AAO_URL_PART_IGP + fipport.toString() + "/webfips";
		}
		SimVar.SetSimVarValue('L:AAO_PANEL_TWO_RELOAD', 'Number', 0);
		SimVar.SetSimVarValue('L:AAO_PANEL_TWO_HIDDEN', 'Number', 0);
		SimVar.SetSimVarValue('L:AAO_PANEL_TWO_BORDER_HIDDEN', 'Number', 0);
		SimVar.SetSimVarValue('L:AAO_PANEL_TWO_ZOOM', 'Number', 0);
		this.ingameUi = document.getElementById("LorbyAaoPanel");
		if (this.ingameUi) {
			this.ingameUi.addEventListener("panelActive", (e) => {
				if (this.panelActive == false) {
					this.panelActive = true;
					this.closeButton = document.getElementsByClassName("Close nodrag")[0];
					if (this.closeButton && !g_externalVariables.vrMode) {
						this.closeButton.Validate = () => { };
						this.closeButton.addEventListener("click", (e) => {
							this.ingameUi.style.display = "none";
						});
					}
				}
			});
		}
		Coherent.on("OnShow", this.onShow);
		Coherent.on("StartHideView", this.onHide);
	}

	initialize() {
		if (this.started) {
			return;
		}
		this.started = true;
	}

	disconnectedCallback() {
		super.disconnectedCallback();
		SimVar.SetSimVarValue('L:AAO_PANEL_TWO_HIDDEN', 'Number', 0);
	}
}
window.customElements.define("ingamepanel-aaofipspanel", IngamePanelAaoFipsPanel);
checkAutoload();